import Vue from 'vue'
import 'normalize.css/normalize.css' // A modern alternative to CSS resets
// import './plugins/jquery.hiwprint.js'
import ElementUI from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'
// import locale from 'element-ui/lib/locale/lang/en' // lang i18n
import { Loading } from 'element-ui'
let loading
function startLoading() {
  loading = Loading.service({
    lock: true,
    text: '拼命加载中...',
    spinner: 'el-icon-loading',
    customClass: '.app-container'
  })
}

function endLoading() {
  loading.close()
}

import * as echarts from 'echarts'
Vue.prototype.$echarts = echarts
import '@/styles/index.scss' // global css
import App from './App'
import store from './store'
import router from './router'

import '@/icons' // icon
import '@/permission' // permission control

import * as filters from './filters' // global filters
import directives from './directives'

import '@zjlib/element-plugins/dest/element-plugins.css'
import ElementPlugins from '@zjlib/element-plugins'
Vue.use(ElementPlugins)

// // 本地引用;
// import ElementPlugins from '@packages'
// Vue.use(ElementPlugins)

// 成功/错误提示
import { successMsg, errorMsg, warningNotify, checkBtnRole, getSummaries, numToFixed } from '@/utils/common.js'
Vue.prototype.$successMsg = successMsg
Vue.prototype.$errorMsg = errorMsg
Vue.prototype.$warningNotify = warningNotify
Vue.prototype.$checkBtnRole = checkBtnRole
Vue.prototype.$getSummaries = getSummaries
Vue.prototype.$numToFixed = numToFixed
Vue.prototype.$startLoading = startLoading
Vue.prototype.$endLoading = endLoading

// 自定义组件
import ExportButton from '@/components/Common/export-button.vue'
Vue.component('ExportButton', ExportButton)
import ImportButton from '@/components/Common/import-button.vue'
Vue.component('ImportButton', ImportButton)
import CopyButton from '@/components/Common/copy-button.vue'
Vue.component('CopyButton', CopyButton)
import Collapse from '@/components/Common/collapse'
Vue.component('Collapse', Collapse)
Vue.prototype.$imageUrl = process.env.VUE_APP_BASE_API + 'img/get?key='

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online ! ! !
 */
if (process.env.NODE_ENV === 'production') {
  const { mockXHR } = require('../mock')
  mockXHR()
}

// set ElementUI lang to EN
// Vue.use(ElementUI, { locale })
// 如果想要中文版 element-ui，按如下方式声明
Vue.use(ElementUI)
// register global utility filters
Object.keys(filters).forEach(key => {
  Vue.filter(key, filters[key])
})

Object.keys(directives).forEach(key => {
  Vue.directive(key, directives[key])
})

Vue.config.productionTip = false

new Vue({
  el: '#app',
  router,
  store,
  render: h => h(App)
})
